#ifndef EFL_GENERATED_ELM_SYSTRAY_HH
#define EFL_GENERATED_ELM_SYSTRAY_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_systray.eo.h"
}

#include "eo_base.eo.hh"
#include <string>

namespace elm {

struct systray;

}

/// @cond EO_CXX_ABSTRACT
namespace eo_cxx {

namespace elm {

struct systray
{
   bool register_() const;

   ::efl::eina::optional< ::efl::eina::string_view > id_get() const;

   void id_set(::efl::eina::optional< ::efl::eina::string_view > id_) const;

   Elm_Systray_Category category_get() const;

   void category_set(Elm_Systray_Category cat_) const;

   ::efl::eina::optional< ::efl::eina::string_view > icon_theme_path_get() const;

   void icon_theme_path_set(::efl::eina::optional< ::efl::eina::string_view > icon_theme_path_) const;

   const Eo * menu_get() const;

   void menu_set(const Eo * menu_) const;

   ::efl::eina::optional< ::efl::eina::string_view > att_icon_name_get() const;

   void att_icon_name_set(::efl::eina::optional< ::efl::eina::string_view > att_icon_name_) const;

   Elm_Systray_Status status_get() const;

   void status_set(Elm_Systray_Status st_) const;

   ::efl::eina::optional< ::efl::eina::string_view > icon_name_get() const;

   void icon_name_set(::efl::eina::optional< ::efl::eina::string_view > icon_name_) const;

   ::efl::eina::optional< ::efl::eina::string_view > title_get() const;

   void title_set(::efl::eina::optional< ::efl::eina::string_view > title_) const;



   static Eo_Class const* _eo_class()
   {
      return(ELM_SYSTRAY_CLASS);
   }

   operator ::elm::systray() const;
   operator ::elm::systray&();
   operator ::elm::systray const&() const;

   /// @cond LOCAL
   template <typename D>
   struct address_of
   {
      operator ::elm::systray*() const { return static_cast<::elm::systray*>(static_cast<D const*>(this)->p); }
      operator ::elm::systray const*() const { return static_cast<::elm::systray const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::elm::systray const*() const { return static_cast<::elm::systray const*>(static_cast<D const*>(this)->p); }
   };
   /// @endcond

private:

   /// @internal
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}

}
/// @endcond

namespace elm {

/// @brief Class systray
struct systray
      : ::efl::eo::concrete
      , EO_CXX_INHERIT(eo::base)
{
   //@{
   /**
      @brief Constructs a new elm::systray object.

      Constructs a new elm::systray object. If you want this object to be a child
      of another Eo object, use an @ref efl::eo::parent expression, like the example.

      Example:
      @code
      elm::systray my_systray(efl::eo::parent = parent_object);
      @endcode

      @see systray(Eo* eo)
   */
   explicit systray(::efl::eo::parent_type _p)
      : systray(_ctors_call(_p))
   {}

   explicit systray()
      : systray(_ctors_call(::efl::eo::parent = nullptr))
   {}
   //@}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit systray(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit systray(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   systray(systray const& other)
      : systray(eo_ref(other._eo_ptr()))
   {}

   ~systray() {}

   bool register_() const;

   ::efl::eina::optional< ::efl::eina::string_view > id_get() const;

   void id_set(::efl::eina::optional< ::efl::eina::string_view > id_) const;

   Elm_Systray_Category category_get() const;

   void category_set(Elm_Systray_Category cat_) const;

   ::efl::eina::optional< ::efl::eina::string_view > icon_theme_path_get() const;

   void icon_theme_path_set(::efl::eina::optional< ::efl::eina::string_view > icon_theme_path_) const;

   const Eo * menu_get() const;

   void menu_set(const Eo * menu_) const;

   ::efl::eina::optional< ::efl::eina::string_view > att_icon_name_get() const;

   void att_icon_name_set(::efl::eina::optional< ::efl::eina::string_view > att_icon_name_) const;

   Elm_Systray_Status status_get() const;

   void status_set(Elm_Systray_Status st_) const;

   ::efl::eina::optional< ::efl::eina::string_view > icon_name_get() const;

   void icon_name_set(::efl::eina::optional< ::efl::eina::string_view > icon_name_) const;

   ::efl::eina::optional< ::efl::eina::string_view > title_get() const;

   void title_set(::efl::eina::optional< ::efl::eina::string_view > title_) const;

   template <typename F>
   ::efl::eo::signal_connection
   callback_callback_add_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (EO_BASE_EVENT_CALLBACK_ADD, priority_,
            &::efl::eo::_detail::event_callback<::elm::systray, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm::systray, function_type>,
         EO_BASE_EVENT_CALLBACK_ADD );
   }

   template <typename T>
   void
   callback_callback_add_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (EO_BASE_EVENT_CALLBACK_ADD, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_callback_del_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (EO_BASE_EVENT_CALLBACK_DEL, priority_,
            &::efl::eo::_detail::event_callback<::elm::systray, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm::systray, function_type>,
         EO_BASE_EVENT_CALLBACK_DEL );
   }

   template <typename T>
   void
   callback_callback_del_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (EO_BASE_EVENT_CALLBACK_DEL, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_del_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (EO_BASE_EVENT_DEL, priority_,
            &::efl::eo::_detail::event_callback<::elm::systray, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm::systray, function_type>,
         EO_BASE_EVENT_DEL );
   }

   template <typename T>
   void
   callback_del_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (EO_BASE_EVENT_DEL, info));
   }



   static Eo_Class const* _eo_class()
   {
      return(ELM_SYSTRAY_CLASS);
   }

   /// @cond LOCAL
   struct address_of
      : ::eo_cxx::elm::systray::address_of<address_of>
      , ::eo_cxx::eo::base::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::elm::systray* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::elm::systray::address_const_of<address_const_of>
      , ::eo_cxx::eo::base::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::elm::systray const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

   /// @endcond

private:

   /// @internal
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(ELM_SYSTRAY_CLASS, _p._eo_raw);

      return _ret_eo;
   }

   /// @internal
   Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::elm::systray) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::elm::systray>::value, "");

}


#include "elm_systray.eo.impl.hh"

#endif // EFL_GENERATED_ELM_SYSTRAY_HH

